System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, Prefab, sp, TextAsset, _crd, bundleConfig;

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      __checkObsolete__ = _cc.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc.__checkObsoleteInNamespace__;
      Prefab = _cc.Prefab;
      sp = _cc.sp;
      TextAsset = _cc.TextAsset;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "7c031pNnkVKr7dEuMs8VZ76", "BundleConfig", undefined);

      /*loadAtLaunch: true//是否加载配置的bundle
      preloadAssets: [
          { path: 'prefabs/main_menu' },
          { path: 'prefabs/loading' },
          { path: 'textures/background', skipLoading: true }这个资源跳过加载
      ],
      autoLoadAll: true //自动加载所有资源
      excludePaths?: [],//要排除的资源路径前缀（当autoLoadAll为true时生效
      excludeExtensions?: []//要排除的文件扩展名（如['.meta']*/
      //游戏初始化资源加载配置

      /*export const bundleConfig: any = new Map([
          ['audios', {
              loadAtLaunch: true,
              autoLoadAll: true //自动加载所有资源
          }],
          ['csb', {
              loadAtLaunch: true,
              preloadAssets: [
                  { path: 'csv/deblock' },
                  { path: 'csv/levels' },
                  { path: 'csv/norm', skipLoading: true } // 这个资源跳过加载
              ]
          }],
          ['prefabs', {
              loadAtLaunch: true, // 不参与启动加载
              preloadAssets: [
                  { path: 'enemies/enemie_01', type: Prefab },
                  { path: 'enemies/enemie_02', type: Prefab },
                  { path: 'texture/msg_hint/spriteFrame', type: SpriteFrame },
                  { path: 'texture/test_01/texture', type: Texture2D },
                  { path: 'texture/test_02/spriteFrame', type: SpriteFrame }
              ]
          }]
      ]);*/
      __checkObsolete__(['Prefab', 'Skeleton', 'sp', 'SpriteFrame', 'TextAsset', 'Texture2D']);

      _export("bundleConfig", bundleConfig = new Map([['audios', {
        loadAtLaunch: true,
        autoLoadAll: true //自动加载所有资源

      }], ['models', {
        loadAtLaunch: true,
        autoLoadAll: true //自动加载所有资源

      }], ['resources', {
        loadAtLaunch: true,
        // 不参与启动加载
        preloadAssets: [{
          path: 'csv/levels',
          type: TextAsset
        }, {
          path: 'csv/model_names',
          type: TextAsset
        }, {
          path: 'prefabs/BusyLoading',
          type: Prefab
        }, {
          path: 'prefabs/Coin',
          type: Prefab
        }, {
          path: 'prefabs/Life',
          type: Prefab
        }, {
          path: 'prefabs/MsgHints',
          type: Prefab
        }, {
          path: 'prefabs/Star',
          type: Prefab
        }, {
          path: 'spine/effect_hecheng',
          type: sp.SkeletonData
        }]
      }]]));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=05528c6b14b85f42fe0b92c470de2cfbc20dd3fa.js.map