import i18n from "../runtime-scripts/LanguageData";
i18n.languages.en = {
    "start": {
        "startGame": "Start"
    },
    "main_1": {
        "%{value}/s": "%{value}/s",
        "free": "free"
    },
    "signReward": {
        "你已经连续签到%{value}天，继续保持": "Sign in for %{value} days，keep on",
        "diamondsNum": "diamonds x2",
    },
    "button": {
        "normalReceive": "<u><color=#ffffff>Normal receive</color></u>",
        "receive": "Receive",
        "directCollection": "<u><color=#ffffff>Receive</color></u>",
        "doubleReceive": "Double",
        "noUpdate": "<u><color=#ffffff>No update</color></u>",
        "giveUpReward": "<u><color=#ffffff>Give up reward</color></u>"
    },
    "main": {
        "dataLoading": "Data loading...",
        "dataLoadOver": "Data loading completed...",
        "loginSuccess": "Login success...",
        "gameResourceLoading": "Game Resource Loading...",
        "audioResourceLoading": "Audio Resource Loading...",
        "mappingResourceLoading": "Mapping resource loading...",
        "modelResourceLoading": "Model resource loading...",
        "entering": "Entering..."
    },
    "mainUI": {
        "start": "Click screen to start",
        "changeCar": "Change cars"
    },
    "shop": {
        "btnClose": "Close",
        "go": "Go",
        "acquired": "Acquired",
        "current": "Current",
        "receive": "Receive",
        "getGold": "Gold coins for watching AD",
    },
    "balance": {
        "你完成了%{value}个订单": "Complete %{value} order",
        "youEarnedIt": "You earned it",
        "clickReceive": "Click revive",
        "receiveImmediately": "Receive Now"
    },
    "carTask": {
        "初始车辆": "Initial vehicle",
        "分享获得": "Share gain",
        "签到获得": "Signin gain",
        "通过关卡获得": "Get through a checkpoint",
    },
    "signin": {
        "title": "Sign in on the 7th",
        "notYet": "Not yet",
        "normalReceive": "Normal receive",
        "receive": "Receive",
        "doubleReceive": "Double receive",
        "fillSignin": "Fill signin"
    },
    "fightManager": {
        "loadingMap": "Loading map...",
        "buildingCity": "Start building cities...",
        "cityLoadOver":"City loaded..."
    },
    "fightMap": {
        "trimTheGround": "The ground is being trimmed...",
        "pavingTheRoad": "Paving the way...",
        "plantingTree": "The trees are being planted...",
        "decorateHouse": "The house is being renovated...",
        "paintLandmarks": "The landmark is being painted..."
    },
    "online": {
        "close": "Close",
        "clickReceive": "Click receive",
        "dailyIncome": "Daily income is available"
    },
    "lottery": {
        "title": "Wheel of fortune",
        "free": "Free"
    },
    "talk": {
        "你好,请到街对面接我.": "Hello, please meet me across the street.",
        "停车!停车!": "Stop the car, please! Stop the car, please!",
        "去消费最高的地方.":"Go to the place where you spend the most.",
        "去附近的希尔顿酒店.":"Go to the nearby hilton hotel.",
        "司机快来!我老婆要生了!":"Driver, come on!  My wife is having a baby!",
        "大哥快点,我赶时间.":"Eldest brother hurry up, I'm in a hurry.",
        "师傅,5分钟内能到吗?": "Master, can you be there in 5 minutes?",
        "师傅,你是老司机嘛?": "Master, are you an old driver?",
        "师傅,你跑一天能赚多少?": "Master, how much do you earn per day?",
        "师傅快点,我要赶飞机.": "Master, hurry up, I have to catch the plane.",
        "师傅跟上那辆法拉利.": "Master, keep up with that Ferrari.",
        "带我去最近的银行.": "Take me to the nearest bank.",
        "帮我跟上前面那辆车!": "Help me keep up with the car in front!",
        "快去火车站,我赶车!": "Go to the railway station, I'll catch the bus!",
        "我在酒店大堂门口等你.": "I'll wait for you at the gate of the hotel lobby.",
        "要下雨了,你快来!": "It's going to rain, you come quickly!"
    },
    "showReward": {
        "title": "Reward",
        "normalReceive": "Normal receive",
        "ReceiveImmediately": " Receive Now",
        "doubleReceive": "Double receive",
        "alreadyHadCar": "You already own the vehicle and automatically convert it into the corresponding gold coin.",
        "buySuccessful": "Buy successful",
        "confrim": "Confrim",
        "signinReward": "Signin reward",
    },
    "revive": {
        "reviveImmediately": "Resurrection Now",
        "skip": "Skip",
        "tips": "It's a pity that we came close to the finish line.!",
        "continue": "Resurrection continues."
    },
    "clickBox": {
        "title": "Mysterious gift",
        "progress": "The faster you click, the more rewards you will receive.",
        "clickMe": "click me fast",
        "normalReceive": "Normal receive",
        "doubleReceive": "Double receive"
    },
    "trial": {
        "title": "Free trial",
        "tryItNow": "Try It Now",
        "giveUp": "Give up the trial and start the game."
    },
    "invinceible": {
        "title": "Invincible start",
        "confirm": "Confrim",
        "close": "Close"
    },
    "setting": {
        "title": "Setting",
        "version": "Version:",
        "close": "Close"
    }
};
